<?php 
//echo "Hola!! Webhook";
//Se usa la funcion file_get_contents() con el fin de obtener los datos del endpoint 
$data = file_get_contents('php://input');
//Se asigna una variable para almacenar el objeto 
$ticket = json_decode($data);
//print_r($ticket);

//Se declara las variables que se usaran en el cuerpo del mensaje.
$id = $ticket->id;                //<-- Variable encargada de almacenar el Id del ticket
$status = $ticket->ticket_status; //<-- Variable encargada de almacenar el estado del ticket
$url = $ticket->public_url;       //<-- Variable encargada de almacenar la url del tiket
$mobile = $ticket->mobile;        //<-- Variable encargada de almacenar el mobil del usuario
$leng = $ticket->ticket_type_leng;//<-- Variable encargada de almacenar el lenguaje

//Funecion encargada de validar el lenguaje del ticket con el fin de enviar el mensaje en el idioma correcto
function &language_Body($status, $leng, $id, $mobile, $url){ 
  if ($leng === "Spanish") {
    $state = ["ABIERTO", "ESPERANDO RESPUESTA", "EN PROGRESO", "RESUELTO", "CERRADO" ];
    switch ($status) {
      case 'Open':
        $status_leng = $state[0];
        break;
      case 'Pending':
        $status_leng = $state[1];
        break;
      case 'Waiting':
        $status_leng = $state[1];
        break;
      case 'Resolved':
        $status_leng = $state[3];
        break;
      case 'Closed':
        $status_leng = $state[4];
        break;
    }
    $body = array(
      "message"=> "Hola, Hemos dado respuesta a tu ticket de soporte #{$id} con estado {$status_leng}. Consulta tu ticket aqui {$url}",
      "tpoa"=> "Sender",
      "recipient"=> array([
        "msisdn" => $mobile
      ])
    );
  }elseif ($leng === "English") {
    $state = ["OPENED", "WAITING ANSWER", "IN PROGRESS", "RESOLVED", "CLOSED" ];
    switch ($status) {
      case 'Open':
        $status_leng = $state[0];
        break;
      case 'Pending':
        $status_leng = $state[1];
        break;
      case 'Waiting':
        $status_leng = $state[1];
        break;
      case 'Resolved':
        $status_leng = $state[3];
        break;
      case 'Closed':
        $status_leng = $state[4];
        break;
    }
    $body = array(
      "message"=> "Hello, We have responded to your ticket #{$id} with {$status_leng} status. Check your ticket here {$url}",
      "tpoa"=> "Sender",
      "recipient"=> array([
        "msisdn" => $mobile
      ])
    );
  }
  return $body;
}

$body =& language_Body($status, $leng, $id, $mobile, $url);
print_r($body);

//Se realizar la llamada a la api de LabsMobile para el envio
$auth_basic = base64_encode("oscar.santa@labsmobile.com:GA6lF92bE7sXGusrlBhUe512pDAjXRtt"); //<-- Se debe indicar el usuario y contraseña o usuario y token de la cuenta LasbsMobile
$curl = curl_init();


curl_setopt_array($curl, array(
  CURLOPT_URL => "https://api.labsmobile.com/json/send",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "POST",
  CURLOPT_POSTFIELDS => json_encode($body),
  CURLOPT_HTTPHEADER => array(
    "Authorization: Basic ".$auth_basic,
    "Cache-Control: no-cache",
    "Content-Type: application/json"
  ),
));

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}

?>